// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('starter', ['ionic'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      StatusBar.styleDefault();
    }
  });
})

.controller('AppCtrl', function($scope, $ionicModal, $ionicPopover, $ionicSlideBoxDelegate, $ionicSideMenuDelegate) {

 $ionicModal.fromTemplateUrl('choose-wand.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });

  $scope.openModal = function() {
    $scope.modal.show();
  };

  $scope.closeModal = function() {
    $scope.modal.hide();
  };

  //Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    $scope.modal.remove();
  });

  // Execute action on hide modal
  $scope.$on('modal.hidden', function() {
    // Execute action
  });

  // Execute action on remove modal
  $scope.$on('modal.removed', function() {
    // Execute action
  });

  /*$ionicPopover.fromTemplateUrl('templates/popover.html', {
    scope: $scope,
  }).then(function(popover) {
    $scope.popover = popover;
  });*/
  
  $scope.chooseWand = function() {
    var slide = $ionicSlideBoxDelegate.currentIndex();
    switch(slide) {
      case 0:
        localStorage.wand = "harry";
        break;
      case 1:
        localStorage.wand = "hermione";
        break;
      case 2:
        localStorage.wand = "ron";
        break;
      case 3:
        localStorage.wand = "dumbledore";
        break;
      case 4:
        localStorage.wand = "voldemort";
        break;
    }
    var currentClass = $("#main-container").attr('class');
    var currentState = currentClass.charAt(6) === "n" ? "wand-on-" : "wand-off-";
    $("#main-container").removeClass(currentClass).addClass(currentState + localStorage.wand);
    $scope.closeModal();
  }

  $scope.nextSlide = function() {
    $ionicSlideBoxDelegate.next();
  };

  $scope.toggleLeft = function() {
    $ionicSideMenuDelegate.toggleLeft();
  };

})