var flashAvailable, flashIsOn;

$(function() {
  localStorage.wand = (localStorage.wand || "harry");
  $("#main-container").addClass("wand-off-" + localStorage.wand);
  $('#toggle-button').on('click', function() {
    toggleFlash();
  });
});

function toggleFlash() {
  if($("#main-container").hasClass("wand-on-" + localStorage.wand)) {
    $("#main-container").removeClass("wand-on-" + localStorage.wand).addClass("wand-off-" + localStorage.wand);
    $('#toggle-button').removeClass("ion-ios-bolt").addClass("ion-ios-bolt-outline");
    turnOffFlash();
  } else {    
    $("#main-container").removeClass("wand-off-" + localStorage.wand).addClass("wand-on-" + localStorage.wand);
    $('#toggle-button').removeClass("ion-ios-bolt-outline").addClass("ion-ios-bolt");
    setTimeout(function() {      
      turnOnFlash();
    }, 50);
  }
}

function turnOnFlash() {
  if(flashAvailable && !flashIsOn) {
    window.plugins.flashlight.switchOn();
    flashIsOn = true;
  }
}

function turnOffFlash() {
  if(flashAvailable && flashIsOn) {          
    window.plugins.flashlight.switchOff();
    flashIsOn = false;
  }
}

function onDeviceReady() {
  flashAvailable = false;
  flashIsOn = false;

  window.plugins.flashlight.available(function(isAvailable) {
    if (isAvailable) {
      flashAvailable = true;
    } else {
      alert("Flashlight not available on this device");
    }
  });

  var maxMatches = 5, language = "en-US", str,
  possibilities = ['lumos', 'knox', 'loomis', 'knocks', 'luminous', 'nox', 'numerous', 'hummus', 'louis', 'nomas', 'numbers', 'lomas'],
  pLength = possibilities.length;

  window.continuoussr.startRecognize(function(result) {
    firstLoop:
    for (var i = 0; i < result.length; i++) {
      str = result[i].toLowerCase();

      for(var j = 0; j < pLength; j++) {
        if(str.indexOf(possibilities[j]) > -1) {
          toggleFlash();
          break firstLoop;
        }
      }
    }

  }, function(errorMessage) {
    alert("Error message: " + errorMessage);
  }, maxMatches, language);

}

function exitApp() {
  navigator.app.exitApp();
}

document.addEventListener("deviceready", onDeviceReady, true);
document.addEventListener("backbutton", function() {
  window.plugins.flashlight.switchOff(exitApp, exitApp);
}, false);

